diff --git a/src/bin/pg_dump/pg_dump.c b/src/bin/pg_dump/pg_dump.c
index a00918bacb4..253c2369897 100644
--- a/src/bin/pg_dump/pg_dump.c
+++ b/src/bin/pg_dump/pg_dump.c
@@ -8120,7 +8120,7 @@ getIndexes(Archive *fout, TableInfo tblinfo[], int numTables)
 				NULL, NULL
 			};
 
-			if (indxinfo[j].parentidx == 0)
+			if (!OidIsValid(indxinfo->parentidx))
 				indexkind = RELKIND_INDEX;
 			else
 				indexkind = RELKIND_PARTITIONED_INDEX;
@@ -8397,7 +8397,7 @@ getConstraints(Archive *fout, TableInfo tblinfo[], int numTables)
 		{
 			Oid			indexOid = atooid(PQgetvalue(res, j, i_conindid));
 
-			if (indexOid != InvalidOid)
+			if (OidIsValid(indexOid))
 			{
 				for (int k = 0; k < reftable->numIndexes; k++)
 				{
@@ -10633,7 +10633,7 @@ getDefaultACLs(Archive *fout)
 		/* cheesy ... is it worth coming up with a better object name? */
 		daclinfo[i].dobj.name = pg_strdup(PQgetvalue(res, i, i_defaclobjtype));
 
-		if (nspid != InvalidOid)
+		if (OidIsValid(nspid))
 			daclinfo[i].dobj.namespace = findNamespace(nspid);
 		else
 			daclinfo[i].dobj.namespace = NULL;
@@ -14005,10 +14005,10 @@ dumpTransform(Archive *fout, const TransformInfo *transform)
 	appendPQExpBuffer(defqry, "CREATE TRANSFORM FOR %s LANGUAGE %s (",
 					  transformType, lanname);
 
-	if (!transform->trffromsql && !transform->trftosql)
+	if (!OidIsValid(transform->trffromsql) && !OidIsValid(transform->trftosql))
 		pg_log_warning("bogus transform definition, at least one of trffromsql and trftosql should be nonzero");
 
-	if (transform->trffromsql)
+	if (OidIsValid(transform->trffromsql))
 	{
 		if (fromsqlFuncInfo)
 		{
@@ -14026,9 +14026,9 @@ dumpTransform(Archive *fout, const TransformInfo *transform)
 			pg_log_warning("bogus value in pg_transform.trffromsql field");
 	}
 
-	if (transform->trftosql)
+	if (OidIsValid(transform->trftosql))
 	{
-		if (transform->trffromsql)
+		if (OidIsValid(transform->trffromsql))
 			appendPQExpBufferStr(defqry, ", ");
 
 		if (tosqlFuncInfo)
@@ -15738,7 +15738,7 @@ dumpTSParser(Archive *fout, const TSParserInfo *prsinfo)
 					  convertTSFunction(fout, prsinfo->prstoken));
 	appendPQExpBuffer(q, "    END = %s,\n",
 					  convertTSFunction(fout, prsinfo->prsend));
-	if (prsinfo->prsheadline != InvalidOid)
+	if (OidIsValid(prsinfo->prsheadline))
 		appendPQExpBuffer(q, "    HEADLINE = %s,\n",
 						  convertTSFunction(fout, prsinfo->prsheadline));
 	appendPQExpBuffer(q, "    LEXTYPES = %s );\n",
@@ -15876,7 +15876,7 @@ dumpTSTemplate(Archive *fout, const TSTemplateInfo *tmplinfo)
 	appendPQExpBuffer(q, "CREATE TEXT SEARCH TEMPLATE %s (\n",
 					  fmtQualifiedDumpable(tmplinfo));
 
-	if (tmplinfo->tmplinit != InvalidOid)
+	if (OidIsValid(tmplinfo->tmplinit))
 		appendPQExpBuffer(q, "    INIT = %s,\n",
 						  convertTSFunction(fout, tmplinfo->tmplinit));
 	appendPQExpBuffer(q, "    LEXIZE = %s );\n",
@@ -17788,7 +17788,7 @@ dumpTableSchema(Archive *fout, const TableInfo *tbinfo)
 			appendStringLiteralAH(q, qualrelname, fout);
 			appendPQExpBufferStr(q, "::pg_catalog.regclass;\n");
 
-			if (tbinfo->toast_oid)
+			if (OidIsValid(tbinfo->toast_oid))
 			{
 				/*
 				 * The toast table will have the same OID at restore, so we
@@ -18361,7 +18361,7 @@ dumpIndex(Archive *fout, const IndxInfo *indxinfo)
 		 * But that's fine, and even if you think it's not, the backend won't
 		 * let us do differently.)
 		 */
-		if (indxinfo->parentidx == 0)
+		if (!OidIsValid(indxinfo->parentidx))
 			appendPQExpBuffer(delq, "DROP INDEX %s;\n", qqindxname);
 
 		if (indxinfo->dobj.dump & DUMP_COMPONENT_DEFINITION)
@@ -20357,7 +20357,7 @@ getFormattedTypeName(Archive *fout, Oid oid, OidOptions opts)
 	PQExpBuffer query;
 	PGresult   *res;
 
-	if (oid == 0)
+	if (!OidIsValid(oid))
 	{
 		if ((opts & zeroAsStar) != 0)
 			return "*";
diff --git a/src/bin/pg_resetwal/pg_resetwal.c b/src/bin/pg_resetwal/pg_resetwal.c
index a31e7643cf0..ebdbffc1336 100644
--- a/src/bin/pg_resetwal/pg_resetwal.c
+++ b/src/bin/pg_resetwal/pg_resetwal.c
@@ -236,7 +236,7 @@ main(int argc, char *argv[])
 					pg_log_error_hint("Try \"%s --help\" for more information.", progname);
 					exit(1);
 				}
-				if (set_oid == 0)
+				if (!OidIsValid(set_oid))
 					pg_fatal("OID (-o) must not be 0");
 				break;
 
@@ -456,7 +456,7 @@ main(int argc, char *argv[])
 	if (set_newest_commit_ts_xid != 0)
 		ControlFile.checkPointCopy.newestCommitTsXid = set_newest_commit_ts_xid;
 
-	if (set_oid != 0)
+	if (OidIsValid(set_oid))
 		ControlFile.checkPointCopy.nextOid = set_oid;
 
 	if (mxid_given)
@@ -829,7 +829,7 @@ PrintNewControlValues(void)
 			   ControlFile.checkPointCopy.nextMultiOffset);
 	}
 
-	if (set_oid != 0)
+	if (OidIsValid(set_oid))
 	{
 		printf(_("NextOID:                              %u\n"),
 			   ControlFile.checkPointCopy.nextOid);
diff --git a/src/bin/psql/describe.c b/src/bin/psql/describe.c
index 36f24502842..94e1c774f6f 100644
--- a/src/bin/psql/describe.c
+++ b/src/bin/psql/describe.c
@@ -3693,7 +3693,7 @@ add_tablespace_footer(printTableContent *const cont, char relkind,
 		 * We ignore the database default tablespace so that users not using
 		 * tablespaces don't need to know about them.
 		 */
-		if (tablespace != 0)
+		if (OidIsValid(tablespace))
 		{
 			PGresult   *result = NULL;
 			PQExpBufferData buf;
diff --git a/src/bin/psql/large_obj.c b/src/bin/psql/large_obj.c
index 28f8c414b67..22032ec2c92 100644
--- a/src/bin/psql/large_obj.c
+++ b/src/bin/psql/large_obj.c
@@ -187,7 +187,7 @@ do_lo_import(const char *filename_arg, const char *comment_arg)
 	loid = lo_import(pset.db, filename_arg);
 	ResetCancelConn();
 
-	if (loid == InvalidOid)
+	if (!OidIsValid(loid))
 	{
 		pg_log_info("%s", PQerrorMessage(pset.db));
 		return fail_lo_xact("\\lo_import", own_transaction);
diff --git a/src/common/relpath.c b/src/common/relpath.c
index 7dcf987afcd..786f915a788 100644
--- a/src/common/relpath.c
+++ b/src/common/relpath.c
@@ -112,7 +112,7 @@ GetDatabasePath(Oid dbOid, Oid spcOid)
 	if (spcOid == GLOBALTABLESPACE_OID)
 	{
 		/* Shared system relations live in {datadir}/global */
-		Assert(dbOid == 0);
+		Assert(!OidIsValid(dbOid));
 		return pstrdup("global");
 	}
 	else if (spcOid == DEFAULTTABLESPACE_OID)
@@ -148,7 +148,7 @@ GetRelationPath(Oid dbOid, Oid spcOid, RelFileNumber relNumber,
 	if (spcOid == GLOBALTABLESPACE_OID)
 	{
 		/* Shared system relations live in {datadir}/global */
-		Assert(dbOid == 0);
+		Assert(!OidIsValid(dbOid));
 		Assert(procNumber == INVALID_PROC_NUMBER);
 		if (forkNumber != MAIN_FORKNUM)
 			sprintf(rp.str, "global/%u_%s",
diff --git a/src/interfaces/libpq/fe-lobj.c b/src/interfaces/libpq/fe-lobj.c
index 05e17bed508..b1c1dfbe146 100644
--- a/src/interfaces/libpq/fe-lobj.c
+++ b/src/interfaces/libpq/fe-lobj.c
@@ -139,7 +139,7 @@ lo_truncate(PGconn *conn, int fd, size_t len)
 		return -1;
 
 	/* Must check this on-the-fly because it's not there pre-8.3 */
-	if (conn->lobjfuncs->fn_lo_truncate == 0)
+	if (!OidIsValid(conn->lobjfuncs->fn_lo_truncate))
 	{
 		libpq_append_conn_error(conn, "cannot determine OID of function %s",
 								"lo_truncate");
@@ -202,7 +202,7 @@ lo_truncate64(PGconn *conn, int fd, int64_t len)
 	if (lo_initialize(conn) < 0)
 		return -1;
 
-	if (conn->lobjfuncs->fn_lo_truncate64 == 0)
+	if (!OidIsValid(conn->lobjfuncs->fn_lo_truncate64))
 	{
 		libpq_append_conn_error(conn, "cannot determine OID of function %s",
 								"lo_truncate64");
@@ -392,7 +392,7 @@ lo_lseek64(PGconn *conn, int fd, int64_t offset, int whence)
 	if (lo_initialize(conn) < 0)
 		return -1;
 
-	if (conn->lobjfuncs->fn_lo_lseek64 == 0)
+	if (!OidIsValid(conn->lobjfuncs->fn_lo_lseek64))
 	{
 		libpq_append_conn_error(conn, "cannot determine OID of function %s",
 								"lo_lseek64");
@@ -482,7 +482,7 @@ lo_create(PGconn *conn, Oid lobjId)
 		return InvalidOid;
 
 	/* Must check this on-the-fly because it's not there pre-8.1 */
-	if (conn->lobjfuncs->fn_lo_create == 0)
+	if (!OidIsValid(conn->lobjfuncs->fn_lo_create))
 	{
 		libpq_append_conn_error(conn, "cannot determine OID of function %s",
 								"lo_create");
@@ -555,7 +555,7 @@ lo_tell64(PGconn *conn, int fd)
 	if (lo_initialize(conn) < 0)
 		return -1;
 
-	if (conn->lobjfuncs->fn_lo_tell64 == 0)
+	if (!OidIsValid(conn->lobjfuncs->fn_lo_tell64))
 	{
 		libpq_append_conn_error(conn, "cannot determine OID of function %s",
 								"lo_tell64");
@@ -674,12 +674,12 @@ lo_import_internal(PGconn *conn, const char *filename, Oid oid)
 	/*
 	 * create an inversion object
 	 */
-	if (oid == InvalidOid)
+	if (!OidIsValid(oid))
 		lobjOid = lo_creat(conn, INV_READ | INV_WRITE);
 	else
 		lobjOid = lo_create(conn, oid);
 
-	if (lobjOid == InvalidOid)
+	if (!OidIsValid(lobjOid))
 	{
 		/* we assume lo_create() already set a suitable error message */
 		(void) close(fd);
@@ -951,56 +951,56 @@ lo_initialize(PGconn *conn)
 	 * (ones that have been added later than the stone age are instead checked
 	 * only if used)
 	 */
-	if (lobjfuncs->fn_lo_open == 0)
+	if (!OidIsValid(lobjfuncs->fn_lo_open))
 	{
 		libpq_append_conn_error(conn, "cannot determine OID of function %s",
 								"lo_open");
 		free(lobjfuncs);
 		return -1;
 	}
-	if (lobjfuncs->fn_lo_close == 0)
+	if (!OidIsValid(lobjfuncs->fn_lo_close))
 	{
 		libpq_append_conn_error(conn, "cannot determine OID of function %s",
 								"lo_close");
 		free(lobjfuncs);
 		return -1;
 	}
-	if (lobjfuncs->fn_lo_creat == 0)
+	if (!OidIsValid(lobjfuncs->fn_lo_creat))
 	{
 		libpq_append_conn_error(conn, "cannot determine OID of function %s",
 								"lo_creat");
 		free(lobjfuncs);
 		return -1;
 	}
-	if (lobjfuncs->fn_lo_unlink == 0)
+	if (!OidIsValid(lobjfuncs->fn_lo_unlink))
 	{
 		libpq_append_conn_error(conn, "cannot determine OID of function %s",
 								"lo_unlink");
 		free(lobjfuncs);
 		return -1;
 	}
-	if (lobjfuncs->fn_lo_lseek == 0)
+	if (!OidIsValid(lobjfuncs->fn_lo_lseek))
 	{
 		libpq_append_conn_error(conn, "cannot determine OID of function %s",
 								"lo_lseek");
 		free(lobjfuncs);
 		return -1;
 	}
-	if (lobjfuncs->fn_lo_tell == 0)
+	if (!OidIsValid(lobjfuncs->fn_lo_tell))
 	{
 		libpq_append_conn_error(conn, "cannot determine OID of function %s",
 								"lo_tell");
 		free(lobjfuncs);
 		return -1;
 	}
-	if (lobjfuncs->fn_lo_read == 0)
+	if (!OidIsValid(lobjfuncs->fn_lo_read))
 	{
 		libpq_append_conn_error(conn, "cannot determine OID of function %s",
 								"loread");
 		free(lobjfuncs);
 		return -1;
 	}
-	if (lobjfuncs->fn_lo_write == 0)
+	if (!OidIsValid(lobjfuncs->fn_lo_write))
 	{
 		libpq_append_conn_error(conn, "cannot determine OID of function %s",
 								"lowrite");
diff --git a/src/pl/plperl/plperl.c b/src/pl/plperl/plperl.c
index 73ba1748fe0..f25216ddfeb 100644
--- a/src/pl/plperl/plperl.c
+++ b/src/pl/plperl/plperl.c
@@ -1270,7 +1270,7 @@ plperl_array_to_datum(SV *src, Oid typid, int32 typmod)
 	int			i;
 
 	elemtypid = get_element_type(typid);
-	if (!elemtypid)
+	if (!OidIsValid(elemtypid))
 		ereport(ERROR,
 				(errcode(ERRCODE_DATATYPE_MISMATCH),
 				 errmsg("cannot convert Perl array to non-array type %s",
@@ -1352,7 +1352,7 @@ plperl_sv_to_datum(SV *sv, Oid typid, int32 typmod,
 		/* must call typinput in case it wants to reject NULL */
 		return InputFunctionCall(finfo, NULL, typioparam, typmod);
 	}
-	else if ((funcid = get_transform_tosql(typid, current_call_data->prodesc->lang_oid, current_call_data->prodesc->trftypes)))
+	else if (OidIsValid((funcid = get_transform_tosql(typid, current_call_data->prodesc->lang_oid, current_call_data->prodesc->trftypes))))
 		return OidFunctionCall1(funcid, PointerGetDatum(sv));
 	else if (SvROK(sv))
 	{
@@ -1612,7 +1612,7 @@ make_array_ref(plperl_array_info *info, int first, int last)
 		{
 			Datum		itemvalue = info->elements[i];
 
-			if (info->transform_proc.fn_oid)
+			if (OidIsValid(info->transform_proc.fn_oid))
 				av_push(result, (SV *) DatumGetPointer(FunctionCall1(&info->transform_proc, itemvalue)));
 			else if (info->elem_is_rowtype)
 				/* Handle composite type elements */
@@ -2195,7 +2195,7 @@ plperl_call_perl_func(plperl_proc_desc *desc, FunctionCallInfo fcinfo)
 	EXTEND(sp, desc->nargs);
 
 	/* Get signature for true functions; inline blocks have no args. */
-	if (fcinfo->flinfo->fn_oid)
+	if (OidIsValid(fcinfo->flinfo->fn_oid))
 		get_func_signature(fcinfo->flinfo->fn_oid, &argtypes, &nargs);
 	Assert(nargs == desc->nargs);
 
@@ -2494,7 +2494,7 @@ plperl_func_handler(PG_FUNCTION_ARGS)
 		}
 		retval = (Datum) 0;
 	}
-	else if (prodesc->result_oid)
+	else if (OidIsValid(prodesc->result_oid))
 	{
 		retval = plperl_sv_to_datum(perlret,
 									prodesc->result_oid,
@@ -3378,7 +3378,7 @@ plperl_return_next_internal(SV *sv)
 
 		tuplestore_puttuple(current_call_data->tuple_store, tuple);
 	}
-	else if (prodesc->result_oid)
+	else if (OidIsValid(prodesc->result_oid))
 	{
 		Datum		ret[1];
 		bool		isNull[1];
diff --git a/src/pl/plpgsql/src/pl_exec.c b/src/pl/plpgsql/src/pl_exec.c
index d19425b7a71..28e616cacfb 100644
--- a/src/pl/plpgsql/src/pl_exec.c
+++ b/src/pl/plpgsql/src/pl_exec.c
@@ -3083,11 +3083,11 @@ exec_stmt_foreach_a(PLpgSQL_execstate *estate, PLpgSQL_stmt_foreach_a *stmt)
 	 * coerce values of different types.  But it seems worthwhile to complain
 	 * if the array-ness of the loop variable is not right.
 	 */
-	if (stmt->slice > 0 && loop_var_elem_type == InvalidOid)
+	if (stmt->slice > 0 && !OidIsValid(loop_var_elem_type))
 		ereport(ERROR,
 				(errcode(ERRCODE_DATATYPE_MISMATCH),
 				 errmsg("FOREACH ... SLICE loop variable must be of an array type")));
-	if (stmt->slice == 0 && loop_var_elem_type != InvalidOid)
+	if (stmt->slice == 0 && OidIsValid(loop_var_elem_type))
 		ereport(ERROR,
 				(errcode(ERRCODE_DATATYPE_MISMATCH),
 				 errmsg("FOREACH loop variable must not be of an array type")));
diff --git a/src/pl/plpython/plpy_procedure.c b/src/pl/plpython/plpy_procedure.c
index 655ab1d09ee..03567e15620 100644
--- a/src/pl/plpython/plpy_procedure.c
+++ b/src/pl/plpython/plpy_procedure.c
@@ -77,7 +77,7 @@ PLy_procedure_get(Oid fn_oid, Oid fn_rel, PLyTrigType is_trigger)
 	PLyProcedure *volatile proc = NULL;
 	bool		found = false;
 
-	if (is_trigger == PLPY_TRIGGER && fn_rel == InvalidOid)
+	if (is_trigger == PLPY_TRIGGER && !OidIsValid(fn_rel))
 		use_cache = false;
 	else
 		use_cache = true;
diff --git a/src/pl/plpython/plpy_typeio.c b/src/pl/plpython/plpy_typeio.c
index d88d10068f3..1b7882d35db 100644
--- a/src/pl/plpython/plpy_typeio.c
+++ b/src/pl/plpython/plpy_typeio.c
@@ -367,9 +367,7 @@ PLy_output_setup_func(PLyObToDatum *arg, MemoryContext arg_mcxt,
 							  typentry->typelem, typmod,
 							  proc);
 	}
-	else if ((trfuncid = get_transform_tosql(typeOid,
-											 proc->langid,
-											 proc->trftypes)))
+	else if (OidIsValid((trfuncid = get_transform_tosql(typeOid, proc->langid, proc->trftypes))))
 	{
 		arg->func = PLyObject_ToTransform;
 		fmgr_info_cxt(trfuncid, &arg->transform.typtransform, arg_mcxt);
@@ -482,9 +480,7 @@ PLy_input_setup_func(PLyDatumToOb *arg, MemoryContext arg_mcxt,
 							 typentry->typelem, typmod,
 							 proc);
 	}
-	else if ((trfuncid = get_transform_fromsql(typeOid,
-											   proc->langid,
-											   proc->trftypes)))
+	else if (OidIsValid((trfuncid = get_transform_fromsql(typeOid, proc->langid, proc->trftypes))))
 	{
 		arg->func = PLyObject_FromTransform;
 		fmgr_info_cxt(trfuncid, &arg->transform.typtransform, arg_mcxt);
diff --git a/src/test/examples/testlo.c b/src/test/examples/testlo.c
index 2277000eddb..6f53908e4bf 100644
--- a/src/test/examples/testlo.c
+++ b/src/test/examples/testlo.c
@@ -53,7 +53,7 @@ importFile(PGconn *conn, char *filename)
 	 * create the large object
 	 */
 	lobjId = lo_creat(conn, INV_READ | INV_WRITE);
-	if (lobjId == 0)
+	if (!OidIsValid(lobjId))
 		fprintf(stderr, "cannot create large object");
 
 	lobj_fd = lo_open(conn, lobjId, INV_WRITE);
@@ -245,7 +245,7 @@ main(int argc, char **argv)
 	printf("importing file \"%s\" ...\n", in_filename);
 /*	lobjOid = importFile(conn, in_filename); */
 	lobjOid = lo_import(conn, in_filename);
-	if (lobjOid == 0)
+	if (!OidIsValid(lobjOid))
 		fprintf(stderr, "%s\n", PQerrorMessage(conn));
 	else
 	{
diff --git a/src/test/examples/testlo64.c b/src/test/examples/testlo64.c
index c303db92e5b..2b8bb1fa0f7 100644
--- a/src/test/examples/testlo64.c
+++ b/src/test/examples/testlo64.c
@@ -54,7 +54,7 @@ importFile(PGconn *conn, char *filename)
 	 * create the large object
 	 */
 	lobjId = lo_creat(conn, INV_READ | INV_WRITE);
-	if (lobjId == 0)
+	if (!OidIsValid(lobjId))
 		fprintf(stderr, "cannot create large object");
 
 	lobj_fd = lo_open(conn, lobjId, INV_WRITE);
@@ -270,7 +270,7 @@ main(int argc, char **argv)
 	printf("importing file \"%s\" ...\n", in_filename);
 /*	lobjOid = importFile(conn, in_filename); */
 	lobjOid = lo_import(conn, in_filename);
-	if (lobjOid == 0)
+	if (!OidIsValid(lobjOid))
 		fprintf(stderr, "%s\n", PQerrorMessage(conn));
 	else
 	{
-- 
2.34.1

